Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 88)
@@ -216,17 +370,63 @@
 	// ===================================================================
 	for (uint32_t i=0; i<_param->_nb_inst_update; i++)
-	  if (internal_UPDATE_VAL[i] and PORT_READ(in_UPDATE_ACK [i]))
+	  if ((internal_UPDATE_VAL[i] and PORT_READ(in_UPDATE_ACK [i])) or
+              (internal_UPDATE_VAL_WITHOUT_ACK [i]))
 	    {
 	      Tcontext_t context = internal_UPDATE_CONTEXT_ID [i];
 	      Tdepth_t   depth   = internal_UPDATE_DEPTH      [i];
-
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"UPDATE[%d] - Accepted",i);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION," * context : %d",context);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION," * depth   : %d",depth);
-
-	      if (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_KO)
-		reg_NB_ELT_NEED_UPDATE [context] --;
-
-	      reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_END;
+	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * UPDATE[%d] - Accepted",i);
+	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * context : %d",context);
+	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * depth   : %d",depth);
+
+              if (internal_UPDATE_FROM_UFPT [i])
+                {
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * Update Fetch Prediction Table");
+                  
+                  // Change state
+#ifdef DEBUG_TEST
+                  if (reg_UPDATE_FETCH_PREDICTION_TABLE [context][depth]._state != UPDATE_FETCH_PREDICTION_STATE_EVENT)
+                    throw ERRORMORPHEO(FUNCTION,_("Update : invalid ufpt state."));
+#endif
+
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UFPT [%d][%d].state <- UPDATE_FETCH_PREDICTION_STATE_END (update)",context,depth);
+
+                  reg_UPDATE_FETCH_PREDICTION_TABLE [context][depth]._state = UPDATE_FETCH_PREDICTION_STATE_END;
+
+                  // Update pointer
+                  reg_UFPT_UPDATE [context] = (depth==0)?(_param->_size_ufpt_queue[context]-1):(depth-1);
+
+                  // Free a register that need update ?
+                  if (need_update(reg_UPDATE_FETCH_PREDICTION_TABLE [context][depth]._condition))
+                    reg_UFPT_NB_NEED_UPDATE [context] --;
+                }
+              else
+                {
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * Update Prediction Table");
+                  
+                  // Change state
+#ifdef DEBUG_TEST
+                  if ((reg_UPDATE_PREDICTION_TABLE [context][depth]._state != UPDATE_PREDICTION_STATE_OK   ) and
+                      (reg_UPDATE_PREDICTION_TABLE [context][depth]._state != UPDATE_PREDICTION_STATE_KO   ) and
+                      (reg_UPDATE_PREDICTION_TABLE [context][depth]._state != UPDATE_PREDICTION_STATE_EVENT))
+                    throw ERRORMORPHEO(FUNCTION,_("Update : invalid upt state."));
+#endif
+
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END (update)",context,depth);
+
+                  reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_END;
+
+                  // Update pointer
+                  if (internal_UPDATE_RAS [i])
+                    reg_UPT_UPDATE [context] = (depth==0)?(_param->_size_upt_queue[context]-1):(depth-1);
+                  else
+                    reg_UPT_UPDATE [context] = (depth+1)%_param->_size_upt_queue[context];
+
+                  // Free a register that need update ?
+                  if (need_update(reg_UPDATE_PREDICTION_TABLE [context][depth]._condition))
+                    reg_UPT_NB_NEED_UPDATE [context] --;
+                  // Free the branch with no accurate ?
+                  if (reg_UPDATE_PREDICTION_TABLE [context][depth]._is_accurate == false)
+                    reg_IS_ACCURATE [i] = true;
+                }
 	    }
 	
@@ -234,52 +434,83 @@
 	reg_UPDATE_PRIORITY = (reg_UPDATE_PRIORITY+1)%_param->_nb_context;
 
-	// ===================================================================
-	// =====[ BRANCH_EVENT ]==============================================
-	// ===================================================================
-	for (uint32_t i=0; i<_param->_nb_context; i++)
-	  if (internal_BRANCH_EVENT_VAL [i] and PORT_READ(in_BRANCH_EVENT_ACK [i]))
-	  {
-	    Tdepth_t depth = internal_BRANCH_EVENT_DEPTH [i];
-	    
-	    reg_UPDATE_PREDICTION_TABLE [i][depth]._state = UPDATE_PREDICTION_STATE_KO;
-	  }
-
-	// ===================================================================
-	// =====[ GARBAGE COLLECTOR ]=========================================
-	// ===================================================================
-
-	for (uint32_t i=0; i<_param->_nb_context; i++)
-	  {
-	    uint32_t bottom = reg_BOTTOM [i];
-	    
-	    // Test if the tail of queue is finish (ok or ko and update)
-	    if (reg_UPDATE_PREDICTION_TABLE [i][bottom]._state == UPDATE_PREDICTION_STATE_END)
-	      {
-		log_printf(TRACE,Update_Prediction_Table,FUNCTION,"GARBAGE_COLLECTOR");
-		log_printf(TRACE,Update_Prediction_Table,FUNCTION," * context : %d",i);
-		log_printf(TRACE,Update_Prediction_Table,FUNCTION," * bottom  : %d",bottom);
-
-		reg_UPDATE_PREDICTION_TABLE [i][bottom]._state = UPDATE_PREDICTION_STATE_EMPTY;
-		reg_BOTTOM [i] = (bottom+1)%_param->_size_queue [i];
-		if (reg_NB_ELT [i]>0)
-		  reg_NB_ELT [i] --;
-	      }
-	  }
-      }
+// 	// ===================================================================
+// 	// =====[ BRANCH_EVENT ]==============================================
+// 	// ===================================================================
+// 	for (uint32_t i=0; i<_param->_nb_context; i++)
+// 	  if (internal_BRANCH_EVENT_VAL [i] and PORT_READ(in_BRANCH_EVENT_ACK [i]))
+//             {
+//               Tdepth_t depth = internal_BRANCH_EVENT_DEPTH [i];
+
+//               if (reg_UPDATE_PREDICTION_TABLE [i][depth]._state == UPDATE_PREDICTION_STATE_EVENT)
+//                 {
+//                   log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * state [%d][%d] <- UPDATE_PREDICTION_STATE_KO (branch_event)",i,depth);
+                  
+//                   reg_UPDATE_PREDICTION_TABLE [i][depth]._state = UPDATE_PREDICTION_STATE_KO;
+//                 }
+//               else
+//                 {
+// #ifdef DEBUG_TEST
+//                   if (reg_UPDATE_PREDICTION_TABLE [i][depth]._state == UPDATE_PREDICTION_STATE_WAITEND_AND_EVENT)
+//                     throw ERRORMORPHEO(FUNCTION,_("Branche event : invalid state"));
+// #endif
+              
+//                   log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * state [%d][%d] <- UPDATE_PREDICTION_STATE_WAITEND (branch_event)",i,depth);
+                  
+//                   reg_UPDATE_PREDICTION_TABLE [i][depth]._state = UPDATE_PREDICTION_STATE_WAITEND;
+//                 }
+//             }
 
 #if (DEBUG >= DEBUG_TRACE)
-    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"Dump Update_Prediction_Table");
-    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * reg_UPDATE_PRIORITY      : %d",reg_UPDATE_PRIORITY);
+    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * Dump Update_Prediction_Table");
+    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPDATE_PRIORITY       : %d",reg_UPDATE_PRIORITY);
     for (uint32_t i=0; i<_param->_nb_context; i++)
       {
-	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * Update_Prediction_Table   [%d]",i);
-	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_TOP                : %d",reg_TOP                [i]);
-	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_BOTTOM             : %d",reg_BOTTOM             [i]);
-	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_NB_ELT             : %d",reg_NB_ELT             [i]);
-	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_NB_ELT_NEED_UPDATE : %d",reg_NB_ELT_NEED_UPDATE [i]);
-	for (uint32_t j=0; j<_param->_size_queue[i]; j++)
-	  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      [%d] %s %x",j,toString(reg_UPDATE_PREDICTION_TABLE [i][j]._state).c_str(),reg_UPDATE_PREDICTION_TABLE [i][j]._address_src);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_IS_ACCURATE           : %d",reg_IS_ACCURATE        [i]);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_STATE           : %s"  ,toString(reg_EVENT_STATE [i]).c_str());
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_RAS_CORRUPTED   : %d"  ,reg_EVENT_RAS_CORRUPTED   [i]);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_ADDRESS_SRC     : %.8x",reg_EVENT_ADDRESS_SRC     [i]);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_ADDRESS_SRC_VAL : %d"  ,reg_EVENT_ADDRESS_SRC_VAL [i]);
+        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_ADDRESS_DEST    : %.8x",reg_EVENT_ADDRESS_DEST    [i]);
+
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * Update_Fetch_Prediction_Table   [%d]",i);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UFPT_BOTTOM         : %d",reg_UFPT_BOTTOM         [i]);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UFPT_TOP            : %d",reg_UFPT_TOP            [i]);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UFPT_NB_NEED_UPDATE : %d",reg_UFPT_NB_NEED_UPDATE [i]);
+	for (uint32_t j=0; j<_param->_size_ufpt_queue[i]; j++)
+	  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"        [%d] %.4d, %.8x %.8x, %.1d   %.1d, %.8d %.8x %.4d - %s",
+                     j,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._condition,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._address_src,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._address_dest,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._last_take,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._is_accurate,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._history,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._address_ras,
+                     reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._index_ras,
+                     toString(reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._state).c_str()
+                     );
+
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * Update_Prediction_Table   [%d]",i);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_BOTTOM          : %d",reg_UPT_BOTTOM         [i]);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_TOP             : %d",reg_UPT_TOP            [i]);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE          : %d",reg_UPT_UPDATE         [i]);
+	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_NB_NEED_UPDATE  : %d",reg_UPT_NB_NEED_UPDATE [i]);
+	for (uint32_t j=0; j<_param->_size_upt_queue[i]; j++)
+	  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"        [%d] %.4d, %.8x %.8x, %.1d %.1d %.1d, %.8d %.8x %.4d - %s",
+                     j,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._condition,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._address_src,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._address_dest,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._last_take,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._good_take,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._is_accurate,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._history,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._address_ras,
+                     reg_UPDATE_PREDICTION_TABLE [i][j]._index_ras,
+                     toString(reg_UPDATE_PREDICTION_TABLE [i][j]._state).c_str()
+                     );
       }
 #endif
+      }
 
 
@@ -287,6 +518,6 @@
     end_cycle ();
 #endif
-
-    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
+    
+    log_end(Update_Prediction_Table,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Parameters.h	(revision 88)
@@ -52,15 +52,15 @@
   public : uint32_t *   _upt_size_queue                ;//[nb_context]
 
-  public : uint32_t     _size_context_id               ;
-  public : uint32_t *   _size_depth                    ;//[nb_context]
-  public : uint32_t     _max_size_depth                ;
-  public : uint32_t *   _size_inst_ifetch_ptr          ;//[nb_context]
+//public : uint32_t     _size_context_id               ;
+//public : uint32_t     _max_size_depth                ;
+//public : uint32_t *   _size_inst_ifetch_ptr          ;//[nb_context]
+  public : uint32_t *   _array_size_depth              ;//[nb_context]
   public : uint32_t     _size_history                  ;
   public : uint32_t *   _size_ras_index                ;//[nb_context]
 						       
-  public : bool         _have_port_context_id          ;
-  public : bool         _have_port_max_depth           ;
-  public : bool     *   _have_port_depth               ;//[nb_context]
-  public : bool     *   _have_port_inst_ifetch_ptr     ;//[nb_context]
+//public : bool         _have_port_context_id          ;
+//public : bool         _have_port_max_depth           ;
+//public : bool     *   _have_port_depth               ;//[nb_context]
+//public : bool     *   _have_port_inst_ifetch_ptr     ;//[nb_context]
   public : bool         _have_port_history             ;
   public : bool     *   _have_port_ras_index           ;//[nb_context]
@@ -95,8 +95,11 @@
 			uint32_t     dir_pht_size_address_share [3],
 			uint32_t *   ras_size_queue                ,//[nb_context]
-			uint32_t *   upt_size_queue                 //[nb_context]
+			uint32_t *   upt_size_queue                ,//[nb_context]
+                        bool         is_toplevel=false
 			);
 //   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Prediction_unit.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Prediction_unit.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/include/Prediction_unit.h	(revision 88)
@@ -114,6 +114,7 @@
 
     // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	      
-  public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_NB_BRANCH                     ; //[nb_context]
-  public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_TAIL                          ; //[nb_context]
+  public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_CURRENT                       ; //[nb_context]
+  public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_MIN                           ; //[nb_context]
+  public    : SC_OUT(Tdepth_t           )  ** out_DEPTH_MAX                           ; //[nb_context]
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Parameters.cpp	(revision 88)
@@ -41,5 +41,6 @@
 			  uint32_t     dir_pht_size_address_share [3],
 			  uint32_t *   ras_size_queue                ,//[nb_context]
-			  uint32_t *   upt_size_queue                 //[nb_context]
+			  uint32_t *   upt_size_queue                ,//[nb_context]
+                          bool         is_toplevel
 			  )
   {
@@ -72,20 +73,13 @@
     _ras_size_queue             = ras_size_queue            ;
     _upt_size_queue             = upt_size_queue            ;
-
-    _size_context_id            = log2(_nb_context);
-//   public : uint32_t *   _size_inst_ifetch_ptr          ;//[nb_context]
-
-    _size_depth                 = new uint32_t [_nb_context];
+    
+    _array_size_depth           = new uint32_t [_nb_context];
     _size_ras_index             = new uint32_t [_nb_context];
+
     for (uint32_t i=0; i<_nb_context; i++)
       {
-	_size_depth     [i] = log2(_upt_size_queue [i]);
-	_size_ras_index [i] = log2(_ras_size_queue [i]);
+	_array_size_depth [i] = log2(_upt_size_queue [i]);
+	_size_ras_index   [i] = log2(_ras_size_queue [i]);
       }
-
-    _max_size_depth             = max<uint32_t>(_size_depth,_nb_context);
-    _have_port_context_id       = (_size_context_id > 0);
-    _have_port_max_depth        = (_max_size_depth  > 0);
-//   public : bool     *   _have_port_inst_ifetch_ptr     ;//[nb_context]
 
     _param_glue = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::prediction_unit_glue   ::Parameters 
@@ -94,5 +88,5 @@
        _size_address          ,
        _nb_instruction        ,
-       _size_depth            ,
+       _array_size_depth      ,
        _nb_inst_decod         ,
        _nb_inst_branch_predict,
@@ -100,9 +94,4 @@
        _nb_inst_branch_update );
 
-    _size_inst_ifetch_ptr      = _param_glue->_size_inst_ifetch_ptr     ;
-    _have_port_depth           = _param_glue->_have_port_depth;
-    _have_port_inst_ifetch_ptr = _param_glue->_have_port_inst_ifetch_ptr;
-    _have_port_history         = (_size_history > 0);
-    
     _param_btb  = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::branch_target_buffer   ::Parameters 
       (_nb_context            ,
@@ -116,5 +105,5 @@
        _nb_inst_branch_update ,
        _btb_victim_scheme     );
-
+    
     _param_dir  = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::direction              ::Parameters 
       (_dir_predictor_scheme      ,
@@ -130,5 +119,6 @@
        _dir_pht_size_address_share);
 
-    _size_history = _param_dir->_size_history;
+    _size_history      = _param_dir->_size_history;
+    _have_port_history = (_size_history > 0);
 
     _param_ras  = new morpheo::behavioural::core::multi_front_end::front_end::prediction_unit::return_address_stack   ::Parameters 
@@ -150,4 +140,23 @@
        _size_history           ,
        _size_ras_index         );
+
+
+    if (is_toplevel)
+      {
+        _size_context_id           = log2(_nb_context);
+        _size_depth                = max<uint32_t>(_array_size_depth,_nb_context);
+        _size_inst_ifetch_ptr      = log2(max<uint32_t>(_nb_instruction,_nb_context));
+        _size_instruction_address  = size_address;
+//      _size_nb_inst_decod        = ;
+//      _size_nb_inst_commit       = ;
+//      _size_ifetch_queue_ptr     = ;
+   
+        _have_port_context_id      = (_size_context_id > 0);
+        _have_port_depth           = (_size_depth  > 0);
+        _have_port_inst_ifetch_ptr = _size_inst_ifetch_ptr > 0;
+//      _have_port_ifetch_queue_ptr= _size_ifetch_queue_ptr > 0;
+
+        copy ();
+      }
 
     test();
@@ -176,6 +185,21 @@
     delete _param_glue;
 
-    delete [] _size_depth    ;
+    delete [] _array_size_depth;
     delete [] _size_ras_index;
+
+    log_printf(FUNC,Prediction_unit,FUNCTION,"End");
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Prediction_unit::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Prediction_unit,FUNCTION,"Begin");
+  
+    COPY(_param_btb );
+    COPY(_param_dir );
+    COPY(_param_ras );
+    COPY(_param_upt );
+    COPY(_param_glue);
 
     log_printf(FUNC,Prediction_unit,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit.cpp	(revision 88)
@@ -37,4 +37,10 @@
     log_printf(FUNC,Prediction_unit,FUNCTION,"Begin");
 
+#if DEBUG_Prediction_unit == true
+    log_printf(INFO,Prediction_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     log_printf(INFO,Prediction_unit,FUNCTION,"Allocation");
 
@@ -46,5 +52,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {	
 	log_printf(INFO,Prediction_unit,FUNCTION,"Allocation of statistics");
@@ -55,5 +61,5 @@
 
 #ifdef VHDL
-    if (_usage & USE_VHDL)
+    if (usage_is_set(_usage,USE_VHDL))
       {
 	// generate the vhdl
@@ -65,5 +71,5 @@
 
 #ifdef SYSTEMC
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	log_printf(INFO,Prediction_unit,FUNCTION,"Method - transition");
@@ -89,5 +95,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {
 	statistics_deallocation();
